/*************************************************
* Common ASN.1 Objects Header File               *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#ifndef BOTAN_ASN1_OBJ_H__
#define BOTAN_ASN1_OBJ_H__

#include <botan/asn1.h>
#include <botan/x509.h>

namespace Botan {

/*************************************************
* AlgorithmIdentifier                            *
*************************************************/
class AlgorithmIdentifier
   {
   public:
      OID oid;
      SecureVector<byte> parameters;

      AlgorithmIdentifier() {}
      AlgorithmIdentifier(const OID&, const SecureVector<byte>&);
      AlgorithmIdentifier(const X509_PublicKey&);
   };

namespace DER {

void encode(DER_Encoder&, const AlgorithmIdentifier&);

}

namespace BER {

void decode(BER_Decoder&, AlgorithmIdentifier&);

}

}

#endif
